=== library/VTKExtensions/Rendering/CMakeLists.txt ===
set(classes
  vtkF3DInteractorEventRecorder
  vtkF3DInteractorStyle
  vtkF3DNoRenderWindow
  vtkF3DOpenGLGridMapper
  vtkF3DOrientationMarkerWidget
  vtkF3DPolyDataMapper
  vtkF3DRenderPass
  vtkF3DRenderer
  vtkF3DRendererWithColoring
  )

vtk_module_add_module(f3d::VTKExtensionsRendering
  FORCE_STATIC
  CLASSES ${classes})
