=== debian/changelog ===
f3d (1.3.1+dfsg-5) unstable; urgency=medium

  * Update changelog to correct typo in the Assimp s390x bug number
    #1023229 instead of #1023212 (Closes: #1023229)

 -- Francois Mazen <francois@mzf.fr>  Sun, 06 Nov 2022 14:17:51 +0100

f3d (1.3.1+dfsg-4) unstable; urgency=medium

  * Improve logging of Assimp error.
  * Do not use Assimp for s390x due to big endian issue
  * Activate OpenCascade module and add relevant autopkgtest

 -- Francois Mazen <francois@mzf.fr>  Mon, 31 Oct 2022 19:15:04 +0100

f3d (1.3.1+dfsg-3) unstable; urgency=medium

  * Activate Assimp module and add relevant autopkgtest
  * Fix spelling error in vtkF3DAssimpImporter

 -- Francois Mazen <francois@mzf.fr>  Sun, 09 Oct 2022 19:19:31 +0200

f3d (1.3.1+dfsg-2) unstable; urgency=medium

  * Increase threshold for image comparison in auto package tests

 -- Francois Mazen <francois@mzf.fr>  Sun, 02 Oct 2022 12:20:26 +0200

f3d (1.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove obsolete patches
  * Bump Standards Version to 4.6.1.0
  * Update debian/copyright with new file paths and add json.hpp
  * Update autopkgtest to use idiff and update reference file
  * Do not install include and lib folders with unnecessary static files
  * Remove usage of CMAKE_SYSTEM_PROCESSOR to fix reproducibility

 -- Francois Mazen <francois@mzf.fr>  Sun, 18 Sep 2022 10:38:20 +0200
