=== debian/control ===
Source: f3d
Section: graphics
Priority: optional
Maintainer: Francois Mazen <francois@mzf.fr>
Build-Depends: debhelper-compat (= 13),
               cmake (>=3.1),
               libassimp-dev [!s390x],
               libocct-data-exchange-dev,
               libocct-draw-dev,
               libocct-foundation-dev,
               libocct-modeling-algorithms-dev,
               libvtk9-dev,
               help2man,
               occt-misc
Standards-Version: 4.6.1.0
Homepage: https://f3d-app.github.io/f3d/
Vcs-Browser: https://salsa.debian.org/debian/f3d
Vcs-Git: https://salsa.debian.org/debian/f3d.git
Rules-Requires-Root: no

Package: f3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and minimalist 3D viewer
 F3D supports many file formats, from digital content to scientific
 datasets (including glTF, stl, ply, obj), can show animations, has
 a lot of rendering options including real time physically based
 rendering and Monte Carlo pathtracing.
