=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
ifeq ($(DEB_HOST_ARCH),s390x)
	USE_ASSIMP=OFF
else
	USE_ASSIMP=ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_SHARED_LIBS=OFF \
	-DF3D_GENERATE_MAN=ON \
	-DF3D_MODULE_ASSIMP=$(USE_ASSIMP) \
	-DF3D_MODULE_OCCT=ON

override_dh_auto_install:
	dh_auto_install
	rm debian/f3d/usr/share/doc/f3d/LICENSE
	rm -r debian/f3d/usr/include
	rm -r debian/f3d/usr/lib
