=== debian/watch ===
version=4
opts=\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/f3d-$1\.tar\.gz/,\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg//,\
repack \
https://github.com/f3d-app/f3d/tags .*/v?(\d\S+)\.tar\.gz
